
Redmine - Feature #13244

Restrict log time for old days

2013-02-21 09:20 - Pavel Potcheptsov

Status: Reopened Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:    

Description

For example any user have to log his spent time today or tomorrow.

If he try to log time for period more than yesterday - it should be not possible.

There are kind of users that sometimes log their time for period weeks ago and this is bad.

Is there any suggestion how to prevent such things.

Related issues:

Related to Redmine - Feature #3322: Setting to restrict spent times on future... Closed 2009-05-08

Related to Redmine - Feature #28308: validation at date of spent time New

Related to Redmine - Feature #13596: Add setting to allow/deny time logging o... Closed

Has duplicate Redmine - Feature #31984: Permission to add timelogs in past Closed

History

#1 - 2013-02-21 11:47 - Jan Niggemann (redmine.org team member)

We need it the other way round and have to be able to log time for weeks ago...

It would need to be configurable.

#2 - 2013-02-22 03:51 - Filou Centrinov

+1 Good idea restricting log time. But I would restrict only for closed issues: #13596

#3 - 2013-06-10 22:00 - Filou Centrinov

- Related to Feature #13596: Add setting to allow/deny time logging on closed issues added

#4 - 2013-10-24 11:30 - Pavel Potcheptsov

someone has been successful in this?

#5 - 2013-11-14 14:30 - Pavel Potcheptsov

- File time_entry.patch added

- Status changed from New to Resolved

#6 - 2016-08-27 06:56 - Go MAEDA

- Status changed from Resolved to New

#7 - 2016-08-27 06:57 - Go MAEDA

- Has duplicate Defect #14840: Time logging shouldn't be possible for the future periods added

#8 - 2016-08-27 07:04 - Go MAEDA

- Has duplicate Feature #3322: Setting to restrict spent times on future dates added

#9 - 2016-08-27 07:06 - Go MAEDA

- Has duplicate deleted (Feature #3322: Setting to restrict spent times on future dates)

#10 - 2016-08-27 07:06 - Go MAEDA

- Is duplicate of Feature #3322: Setting to restrict spent times on future dates added
#11 - 2016-08-27 07:06 - Go MAEDA

- Has duplicate deleted (Defect #14840: Time logging shouldn't be possible for the future periods)

#12 - 2016-08-27 07:09 - Go MAEDA

- Status changed from New to Closed

- Resolution set to Duplicate

Closing as a duplicate of #3322.

#13 - 2016-08-29 08:04 - Toshi MARUYAMA

- Related to deleted (Feature #13596: Add setting to allow/deny time logging on closed issues)

#14 - 2016-08-29 08:04 - Toshi MARUYAMA

- Related to Feature #13596: Add setting to allow/deny time logging on closed issues added

#15 - 2016-08-29 08:04 - Toshi MARUYAMA

- Related to deleted (Feature #13596: Add setting to allow/deny time logging on closed issues)

#16 - 2016-08-30 10:32 - Pavel Potcheptsov

- File time_entry.diff added

Last line in diff gives ability to restrict log time for specified number of days and exclude specific users from this restriction.

#17 - 2016-09-09 12:13 - Toshi MARUYAMA

Pavel Potcheptsov wrote:

Last line in diff gives ability to restrict log time for specified number of days and exclude specific users from this restriction.

 I have noted at #3322#note-11 because this issue is closed as duplicate.

#18 - 2017-03-27 06:49 - Kirill Marchuk

Why is this considered a duplicate ? This is a totally legitimate and self-standing use case: for some projects, I want to have a strict discipline in

regards with spent time logging. So I want to be sure that the users on this project are allowed to log time ONLY for today AND X working days before

(where X most probably equals to 1)

Does anyone know of a plugin that would allow for such functionality? Or might it be included in Redmine itself ?

#19 - 2017-03-27 10:37 - Pavel Potcheptsov

- Status changed from Closed to Reopened

Kirill Marchuk wrote:

Why is this considered a duplicate?

 Agree.

Does anyone know of a plugin that would allow for such functionality? Or might it be included in Redmine itself ?

 At least current patch allow this for all projects.

There might be some general system wide setting for this and dedicated per each project setting.

#20 - 2017-03-28 03:55 - Kirill Marchuk

any chances this will be merged into redmine [soon] ?

#21 - 2017-04-07 03:59 - Kirill Marchuk

hello, anyone ? does Redmine have a community ?

#22 - 2017-04-07 04:05 - Kirill Marchuk
pavel ochman, may be you can change "resolution" for this issue ?

#23 - 2017-04-11 08:58 - Pavel Potcheptsov

No I can't.

#24 - 2017-05-18 17:09 - Kirill Marchuk

is there anyone alive here ? why are patches ignored ? Man spent his time and effort into it, he deserves at least a reaction !!!

#25 - 2017-05-24 19:01 - Kirill Marchuk

well, I've seen the patch finally ))

this is NOT something that's possible to merge into upstream. just a couple of hard-coded validation checks.

Proper implementation would require a per-project setting of:

is time logging restricted for this project at all

how many days in the past are allowed to log time on (0 is minimum, which means you can only log time on today)

if this sounds bad, please leave your comments

#26 - 2017-06-23 14:58 - Toshi MARUYAMA

- Is duplicate of deleted (Feature #3322: Setting to restrict spent times on future dates)

#27 - 2017-06-23 14:58 - Toshi MARUYAMA

- Related to Feature #3322: Setting to restrict spent times on future dates added

#28 - 2018-04-03 02:33 - Go MAEDA

- Related to Feature #28308: validation at date of spent time added

#29 - 2019-03-29 18:17 - Guillermo ML

If anyone is interested a coworker made this plugin: https://github.com/cerxal/estatisticas

It does a lot of things, but it includes a field called Numero máximo de dias sin incurrir horas = Maximum number of days to log spent time so users

can only log time X days ago, if you try to log X+1 days ago it will raise an error.

We are using it in 3.4.4 (also in 3.3.1). Don't know if it will work in other versions.

Maybe you can use part of the source code to do your own dedicate plugin.

#30 - 2019-04-01 10:40 - Pavel Potcheptsov

Thanks you for information.

Do you know if there an option to exclude certain users from that restriction?

#31 - 2019-04-02 16:53 - Guillermo ML

Pavel Potcheptsov wrote:

Do you know if there an option to exclude certain users from that restriction?

 No, it applies to all users on all projects.

#32 - 2019-08-03 21:37 - Jan K.

We would like to have this functionality as well. IO agree with  Kirill and Pavel. Important feature.

We have the same problem In our use case. Users should log their time max 1-3 days back butthey do it just to fiil the time. I'd like to restrict it. If they

do not log the time properly, they should have a problem which can solve only someone with higher privilegy.

#33 - 2019-08-30 17:16 - Mischa The Evil

- Has duplicate Feature #31984: Permission to add timelogs in past added

#34 - 2019-08-30 20:37 - Aleksandar Pavic

+1 see my comments from #31984

#35 - 2019-11-27 08:43 - Ashwin Date

- File issue_13244.patch added
I have created a patch based on the master git branch for this feature. This patch allows

1. Global configuration in the "Time Tracking" tab in the settings that allows setting how many days in the past time logs can be added. Default is 999

days

2. Once the configuration is set, the date of the time log cannot be older than x days in the past. x is the value configured in the above setting.

Patch attached.

#36 - 2019-11-27 08:58 - Ashwin Date

- File issue_13244.patch added

Corrected spelling for "time logs"

#37 - 2020-05-11 11:12 - Mitrajit Samanta

Ashwin Date wrote:

Corrected spelling for "time logs"

 Hi Aswin, please tell me how to use this patch in Redmine.

#38 - 2020-07-01 13:25 - Pavel Potcheptsov

Ashwin Date wrote:

I have created a patch based on the master git branch for this feature.

 Hi there.

Your path works great however I didn't make any changes in app/controllers/issues_controller.rb. Can you describe what is the purpose of that

changes?

Do you know how to implement changes so that to add setting to choose users who is excluded from past time log restriction?

For now I have to use this line with hardcoded users IDs:

errors.add :spent_on, :invalid if \

(days_diff.to_i  > Setting.timelog_max_days_before.to_i) && \

([10,20,30,110].exclude? User.current.id)

#39 - 2021-02-28 20:40 - Some Proton

i use

 errors.add :spent_on,  "is too early" if (spent_on < Date.today - 5.day)

   end

 successfully, but like to restrict time logs to the current month, u should not be able to log time in any other month except the current month. so u can

only log the time in march, as soon as its 1st of march.  im no ruby or redmine coder, can someone help me with this?

#40 - 2024-03-08 20:03 - Sergey Neustruev

Pavel Potcheptsov wrote in #note-38:

Ashwin Date wrote:

I have created a patch based on the master git branch for this feature.

 Hi there.

Your path works great however I didn't make any changes in app/controllers/issues_controller.rb. Can you describe what is the purpose of that

changes?

 Greetings!

I warn you right away, I'm still not well versed in Ruby and Redmine, but I needed to fix the patch that was in this branch.

Do you know how to implement changes so that to add setting to choose users who is excluded from past time log restriction?

For now I have to use this line with hardcoded users IDs:

 The corrections were made so that one of the groups could be granted the rights to change. The group can be replenished separately with redmine
funds without having to get into the code.

app/models/time_entry.rb

      days_diff = (Date.today - spent_on)

      time_group_name = Setting.timelog_groups_exclude

      time_group = Group.find_by_lastname(time_group_name)

      time_group_id = time_group.id if time_group

      time_users_list = time_group.users if time_group

      time_user_array = []                                                                                  

      time_users_list.each do |user|

        user_id = user.id

        time_user_array.push(user.id)

      end

      errors.add :spent_on, :invalid if \                                                                   

      (days_diff.to_i  > Setting.timelog_max_days_before.to_i) && \

      (time_user_array.exclude? User.current.id)

                                                                

      time_user_array.clear

 app/views/settings/_timelog.html.erb

<p><%= setting_select :timelog_groups_exсlude, Group.where(["type IN (?)",['User','Group']]).order("users.lastname ASC").each {|u| [u.name.to_s,

u.id]}, :blank => :label_none, :label => :setting_timelog_groups_exclude %></p>

config/locales/en-GB.yml

setting_timelog_groups_exclude: Users group for exclude

config/settings.yml

timelog_groups_exclude:

default: ''

<If you think that something needs to be fixed, write.

#41 - 2024-03-11 05:13 - Sergey Neustruev

app/models/time_entry.rb

     days_diff = (Date.today - spent_on).to_i

      time_group = Group.find_by_lastname(Setting.timelog_groups_exclude)

      users_in_group = time_group.users.map(&:id) if time_group

      if days_diff > Setting.timelog_max_days_before.to_i && !users_in_group.include?(User.current.id) && !(

User.current.admin?)

        errors.add :spent_on, :invalid

      end

#42 - 2024-08-07 10:37 - Eser Esen

Hi,

i would like to block adding or changing time entries at all if, for example, then spent_on is on last month, and number of day in current month is like

>= 5. Only allow admins to do so, no seetings needed.

Im not really sure where exactly to put it on the time_entry.rb file, could someone explain? Is it the "validate_time_entry" method?

#43 - 2024-08-07 22:55 - Pavel Potcheptsov

Eser Esen wrote in #note-42:

Hi,

i would like to block adding or changing time entries at all if, for example, then spent_on is on last month, and number of day in current month is

like >= 5. Only allow admins to do so, no seetings needed.

 Well you can follow my original patch and do something like that, i.e. throw error if current day is more then 05 in current month and spent time is in

the past month and hardcode users's id to exclude from this condition:

errors.add :spent_on,  "is too early" if (spent_on <= Date.today.prev_month.end_of_month && Date.today.day >= 

5) && ([admin_id1,admin_id2].exclude? User.current.id)

#44 - 2024-08-13 12:42 - Go MAEDA
- File clipboard-202408131924-kdik4.png added

- File clipboard-202408131925-appd3.png added

- File 13244.patch added

- Target version set to Candidate for next major release

- Resolution deleted (Duplicate)

I wrote a new patch similar to issue_13244.patch by Ashwin Date.

You can restrict users from logging time on past dates by configuring the "Accept time logs within the past N days" setting ("Administration" >

"Settings" > "Time tracking").

The default value of this setting is 36525 days (approximately 100 years), which effectively means the restriction is virtually unlimited unless

specifically configured.

 clipboard-202408131924-kdik4.png 

 clipboard-202408131925-appd3.png 

#45 - 2024-08-13 12:50 - Pavel Potcheptsov

Wow!

Although I'm not an active user of Remine anymore still glad the project has such a valuable contributors.

#46 - 2024-08-13 21:37 - Marius BĂLTEANU

- File 0001-Setting-to-restrict-adding-editing-deleting-log-time.patch added

Several years ago, I developed a similar patch using a different approach. It included:

A setting to lock dates older than N days.

A permission to allow adding, editing, or deleting time entries on locked dates.

I can update the existing patch or merge both solutions if you believe the permission would be beneficial.

I'm attaching the patch only for inspection because it needs some updates in order to cleanly apply on the current trunk.

#47 - 2024-12-09 09:49 - Jens Krämer

- File clipboard-202412091647-xgjdu.png added

- File 0001-project-setting-to-deny-time-logging-on-closed-issue.patch added

Upon user request, we have developed a very simple solution at Planio, which allows to disable time logging on closed issues on a per-project basis

(in the project settings / issue tracking tab):

 clipboard-202412091647-xgjdu.png 

#48 - 2024-12-09 23:15 - Marius BĂLTEANU

- Related to Feature #13596: Add setting to allow/deny time logging on closed issues added

#49 - 2024-12-11 21:01 - Marius BĂLTEANU

Jens Krämer wrote in #note-47:

Upon user request, we have developed a very simple solution at Planio, which allows to disable time logging on closed issues on a per-project

basis (in the project settings / issue tracking tab):

[..]

Thanks for the patch! I'm not sure at which version is Plan.io right now, but in standard Redmine, we already have 2 global settings similar to this one:

Accept time logs with 0 hours

Accept time logs on future dates

I fully agree that having the option to override some settings at the project level is very useful. Until that feature is available, I prefer to add this setting

next to the existing ones. I've posted a new patch based on your work in #13596. Let's continue the discussion there.

#50 - 2024-12-11 23:36 - Marius BĂLTEANU

- File 0001-Rework patch-from-13244.patch added

- Target version changed from Candidate for next major release to 6.1.0
Go MAEDA wrote in #note-44:

I wrote a new patch similar to issue_13244.patch by Ashwin Date.

You can restrict users from logging time on past dates by configuring the "Accept time logs within the past N days" setting ("Administration" >

"Settings" > "Time tracking").

The default value of this setting is 36525 days (approximately 100 years), which effectively means the restriction is virtually unlimited unless

specifically configured.

[..]

 Go MAEDA, I've reworked a little bit your patch in order to be in the same direction with the similar settings that we already have. What do you think?

#51 - 2024-12-12 12:23 - Go MAEDA

Marius BĂLTEANU wrote in #note-50:

Go MAEDA, I've reworked a little bit your patch in order to be in the same direction with the similar settings that we already have. What do you

think?

 Thank you for taking care of this.

I think that with Planio's new "Time tracking on closed issues" setting, the additional setting to restrict time entries for past dates that I proposed may

not be necessary. This new setting seems sufficient to cover many use cases, and adding a restriction for past dates on top of this might increase

complexity. Adding too many settings could make it cumbersome for users to manage configurations effectively.

#52 - 2024-12-16 06:33 - Jens Krämer

Marius BĂLTEANU wrote in #note-49:

I fully agree that having the option to override some settings at the project level is very useful. Until that feature is available, I prefer to add this

setting next to the existing ones. I've posted a new patch based on your work in #13596. Let's continue the discussion there.

 Thank you Marius, that makes sense. I guess #4015 is what you mean regarding project level setting overrides?

#53 - 2024-12-16 13:20 - Marius BĂLTEANU

Jens Krämer wrote in #note-52:

Marius BĂLTEANU wrote in #note-49:

I fully agree that having the option to override some settings at the project level is very useful. Until that feature is available, I prefer to add

this setting next to the existing ones. I've posted a new patch based on your work in #13596. Let's continue the discussion there.

 Thank you Marius, that makes sense. I guess #4015 is what you mean regarding project level setting overrides?

 Yes, that is the ticket.

#54 - 2025-03-30 09:57 - Marius BĂLTEANU

- Target version changed from 6.1.0 to Candidate for next major release

Go MAEDA wrote in #note-51:

[..]

 I think that with Planio's new "Time tracking on closed issues" setting, the additional setting to restrict time entries for past dates that I proposed

may not be necessary. This new setting seems sufficient to cover many use cases, and adding a restriction for past dates on top of this might

increase complexity. Adding too many settings could make it cumbersome for users to manage configurations effectively.

 The setting to allow/deny time logging on closed issues have been added in r23586 for #13596. For now, I'm removing this issue from 6.1.0 until we

get more feedback if this new setting is really needed on top of the newly one.

Files

time_entry.patch 460 Bytes 2013-11-14 Pavel Potcheptsov

time_entry.diff 1.42 KB 2016-08-30 Pavel Potcheptsov
issue_13244.patch 8.78 KB 2019-11-27 Ashwin Date

issue_13244.patch 8.78 KB 2019-11-27 Ashwin Date

clipboard-202408131924-kdik4.png 84.6 KB 2024-08-13 Go MAEDA

clipboard-202408131925-appd3.png 63.9 KB 2024-08-13 Go MAEDA

13244.patch 3.84 KB 2024-08-13 Go MAEDA

0001-Setting-to-restrict-adding-editing-deleting-log-time.patch 7.81 KB 2024-08-13 Marius BĂLTEANU

clipboard-202412091647-xgjdu.png 12.3 KB 2024-12-09 Jens Krämer

0001-project-setting-to-deny-time-logging-on-closed-issue.patch 10.4 KB 2024-12-09 Jens Krämer

0001-Rework patch-from-13244.patch 4.68 KB 2024-12-11 Marius BĂLTEANU
